-- SQL e-PRTR Entfernung von Betrieben, die weder Freisetzungen noch
-- Verbringungen haben

-- (c) ENDA GmbH & Co. KG, 2011
-- Dieses Skript steht unter GNU Gpl. V3

-- Rev. 0, 2011-03-21 16:00, mlt: Umstellung auf Nutzung von k_laender_fuer_aktualisierung für 2007, 2008 und 2009


-- SEQUENZEN AUFFRISCHEN --

select risa_adjust_sequences();
select model.risa_adjust_sequences();


-- GIS-Easy-Tabellen säubern:


-- 2007: Einträge derjenigen Betriebe löschen, die weder Freisetzungen noch Verbringungen haben:
delete from suchtabelle_2007 st
using betriebe_2007 b
where st.betrieb_id  = b.id
  and b.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);

delete from betriebe_2007 b
where b.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);

delete from betriebe_gis_2007 bg
where bg.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);

-- 2008: Einträge derjenigen Betriebe löschen, die weder Freisetzungen noch Verbringungen haben:
delete from suchtabelle_2008 st
using betriebe_2008 b
where st.betrieb_id  = b.id
  and b.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);

delete from betriebe_2008 b
where b.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);

delete from betriebe_gis_2008 bg
where bg.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);

-- 2009: Einträge derjenigen Betriebe löschen, die weder Freisetzungen noch Verbringungen haben:
delete from suchtabelle_2009 st
using betriebe_2009 b
where st.betrieb_id  = b.id
  and b.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);

delete from betriebe_2009 b
where b.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);

delete from betriebe_gis_2009 bg
where bg.p_betrieb_id in
(
select distinct b2.id
from p_betrieb b2
  inner join k_laender_fuer_aktualisierung ka
    on b2.date_from = ka.jahr * 10000 +  101
    and b2.date_to  = ka.jahr * 10000 + 1231
    and b2.land_id  = ka.land_id
  left join p_freis f
    on b2.id = f.p_betrieb_id
  left join p_vabw vaw
    on b2.id = vaw.p_betrieb_id
  left join p_vabf vaf
    on b2.id = vaf.p_betrieb_id
where f.p_betrieb_id is null
  and vaw.p_betrieb_id is null
  and vaf.p_betrieb_id is null
);
